#!/bin/sh

G_NM=/bin/nm; export G_NM
G_GREP=/bin/grep; export G_GREP
G_SED=/bin/sed; export G_SED

inits=`${G_NM} $* | \
	${G_GREP} 'fm_module_init' | \
	${G_SED} -e 's/\(_fm_module_init[^ 	\.\|]*\)\([\.\|].*\)$/\1/'`


for init in $inits
do
echo "extern void $init();"
done

echo ""

echo "void _fm_linktime_init()"
echo "{"
for init in $inits
do
echo "    $init();"
done
echo "}"
