// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "fmc_defs.h"
#include "global.h"

SgExpression *fmIOVarExp(SgExpression *);
SgStatement  *checkIOStat(int,SgExpression *,SgExpression *,SgExpression *);
SgExpression *portExp(SgExpression *);

void doEndchannelStmt(SgStatement *s)
{
    SgEndchannelStmt *endChannel = isSgEndchannelStmt(s);
    SgCallStmt *callStmt        = new SgCallStmt(*fmEndChannelCallSymb);
    SgExpression   *outport     = portExp(endChannel->outport(0));
    SgExpression   *ioStore     = endChannel->ioStore();
    SgExpression   *errLabel    = endChannel->errLabel();
    SgExpression   *ioArg;

    callStmt->addArg(*outport);
    ioArg = fmIOVarExp(ioStore);
    callStmt->addArg(*ioArg);
    s->insertStmtBefore(*callStmt);
    s->insertStmtBefore(*checkIOStat(1,ioStore,ioArg,errLabel));

    fmStmtSLL.append(s);
}

    
