// This file may look like C but it is really -*- C++ -*-

// Please see the COPYRIGHT_and_DISCLAIMER file in the top level
// directory of the distribution regarding the provisions under
// which this software is distributed

#include "sage++user.h"
#include "variant.h"

static char *tag[MAXIMUM_SAGEXX_TAGS];

void initVariantNames()
{
    for (int i = 0; i < MAXIMUM_SAGEXX_TAGS; i++) {
	tag[i] = 0;
    }
#include "../h/tag.h"
}

char *getVariantByName(int variant)
{
    if ((variant >= 0 && variant < MAXIMUM_SAGEXX_TAGS) && tag[variant]) {
	return (tag[variant]);
    } else {
	return( (char *) 0);
    }
}

void printVariantName(int variant)
{
    char *variantName = getVariantByName(variant);
    if (variantName) {
	printf("%s", variantName);
    } else {
 	printf("Unknown variant: %d\n", variant);
    }
}

      
